#include <fstream>
#include <iostream>
#include <cassert>
#include <algorithm>
#include <map>
 using namespace std;
#include "ddouble.h"
#include <time.h> 
inline ddouble CPUtime(){
#ifdef SYSTIMES
  struct tms buf;
  if (times(&buf)!=-1)
    return ((ddouble)buf.tms_utime+(ddouble)buf.tms_stime)/(long) sysconf(_SC_CLK_TCK);
  else
#endif
    return ((double) clock())/CLOCKS_PER_SEC;
}

#define KN_CHECK
#include "RNM.hpp"
#include "GCDA.hpp"
typedef ddouble R; 

class MatriceMap: VirtualMatrice<R> { public:
 typedef  VirtualMatrice<R>::plusAx plusAx;
  typedef map<pair<int,int>,R> Map;
  
  const Map &m;
  MatriceMap(const Map & mm) :m(mm) {} 
 void addMatMul(const KN_<R> & x, KN_<R> & Ax) const ;  
 plusAx operator*(const KN<R> &  x) const {return plusAx(this,x);} 
}; 
 
 void MatriceMap::addMatMul(const KN_<R> & x, KN_<R> & Ax) const {  
   for ( Map::const_iterator k=m.begin(); k != m.end(); ++k)
     { 
       int i= k->first.first;
       int j= k->first.second;
       R  aij= k->second;
       Ax[i] += aij*x[j];
     }
  }


int main(int argc,char ** argv)
 {       
typedef KN<ddouble> Rn;
typedef KN_<ddouble> Rn_;
typedef KNM<ddouble> Rnm;
typedef KNM_<ddouble> Rnm_;
     


  {
    //  - Delta u = 1 
    int N = 100;
    int N1= N+1;
    ddouble h(1./N);
    ddouble cc( -1,1);
    ddouble aa= cc*-4/(h*h);
    ddouble bb= cc/(h*h);
    map< pair<int,int> , ddouble> A; 
 
    for (int i0=1;i0<N;i0++)
      for (int i1=1;i1<N;i1++)
	{ 
	  int i = i0*N1+i1;
	  int jj[4] = { (i0-1)*N1+i1, (i0+1)*N1+i1, (i0)*N1+i1-1, (i0)*N1+i1+1 };
	  A[make_pair(i,i)] = aa;
	  for (int k=0;k<4;++k)
	    A[make_pair(i,jj[k])] = bb;
	}

    int n = N1*N1;
    Rn b(n),x(n);
    b =ddouble(0.);
    for (int i0=1;i0<N;i0++)
      for (int i1=1;i1<N;i1++)
	{ 
	  int i = i0*N1+i1;
	  b[i]=1;
	}
    x=ddouble(0.);
    R t0=CPUtime();
    GradienConjugue(MatriceMap(A),MatriceIdentite<R>() ,b,x,n,1e-5);
    cout << " Temps cpu = " << CPUtime() - t0<< "s" << endl;
    R xmax= x.max();
    cout << " x.max() = "<< xmax <<  endl;
    ofstream ff("pp.gp");
    for (int i0=0;i0<=N;i0++)
      {
      for (int i1=0;i1<=N;i1++)
        {
          int i = i0*N1+i1;
          ff << i0 << " " << i1 << " " << x[i][0] << " " << x[i][1] << endl;
        }
      ff << endl ;
      }
    }
  return 0;
}
