// la regle de programmation 3  
#include "assertion.hpp" 
#include <cstdlib>

// some usefull function
template<class T> inline T Min (const T &a,const T &b){return a < b ? a : b;}
template<class T> inline T Max (const T &a,const T & b){return a > b ? a : b;}
template<class T> inline T Abs (const T &a){return a <0 ? -a : a;}
template<class T> inline double Norme (const T &a){return sqrt(a*a);}
template<class T> inline void Exchange (T& a,T& b) {T c=a;a=b;b=c;}
template<class T> inline T Max (const T &a,const T & b,const T & c){return Max(Max(a,b),c);}
template<class T> inline T Min (const T &a,const T & b,const T & c){return Min(Min(a,b),c);}

using namespace std;
// definition R

#include "R2.hpp"

class Label {  // reference number for the physics
  friend inline ostream& operator <<(ostream& f,const Label & r  )
    { f <<  r.lab ; return f; }
  friend inline istream& operator >>(istream& f, Label & r  )
    { f >>  r.lab ; return f; }
  public: 
  int lab;
  Label(int r=0):lab(r){}
  bool onGamma() const { return lab;} 
  };
  

//sommets

class Vertex : public R2,public Label {
  friend inline ostream& operator <<(ostream& f, const Vertex & v )
    { f << (R2) v << ' ' << (Label &) v   ; return f; }
  friend inline istream& operator >> (istream& f,  Vertex & v )
      { f >> (R2 &) v >> (Label &) v ; return f; }
   public:
   Vertex() : R2(),Label(){};
   Vertex(R2 P,int r=0): R2(P),Label(r){}
   private: // pas de copie pour ne pas prendre l'adresse
     Vertex(const Vertex &);
     void operator=(const Vertex &); 
};

class Triangle: public Label {
  // variable prive 
  Vertex *vertices[3]; // an array of 3 pointer to vertex
  public:
  R area;
  Triangle() :area() {}; // constructor empty for array
  Vertex & operator[](int i) const {
     ASSERTION(i>=0 && i <3);
     return *vertices[i];} // to see traingle as a array of vertex
  void set(Vertex * v0,int i0,int i1,int i2,int r) 
    { vertices[0]=v0+i0; vertices[1]=v0+i1; vertices[2]=v0+i2; 
      R2 AB(*vertices[0],*vertices[1]);
      R2 AC(*vertices[0],*vertices[2]);
      area = (AB^AC)*0.5;
      lab=r;
      ASSERTION(area>0);    
    }
  R2 Edge(int i) const {ASSERTION(i>=0 && i <3);
      return R2(*vertices[(i+1)%3],*vertices[(i+2)%3]);}// opposite edge vertex i   ( bord = edge )
  R2 H(int i) const { ASSERTION(i>=0 && i <3);
      R2 E=Edge(i);return E.perp()/(2*area);} // heigth 
  R lenEdge(int i) const {ASSERTION(i>=0 && i <3);
      R2 E=Edge(i);return sqrt((E,E));}
 private:
   Triangle(const Triangle &); // pas de construction par copie
   void operator=(const Triangle &);// pas affectation par copy 
  
};

class Mesh { public:
  int nt,nv;
  R area;
  Vertex *vertices;
  Triangle *triangles;
  Triangle & operator[](int i) const {return triangles[CheckT(i)];}
  Vertex & operator()(int i) const {return vertices[CheckV(i)];}
  Mesh(const char * filename); // read on a file
  int operator()(const Triangle & t) const {return CheckT(&t - triangles);}
  int operator()(const Triangle * t) const {return CheckT(t - triangles);}
  int operator()(const Vertex & v) const {return CheckV(&v - vertices);}
  int operator()(const Vertex * v) const{return CheckV(v - vertices);}
  int operator()(int it,int j) const {return (*this)(triangles[it][j]);}// Nu vertex j of traingle it
  //  to check the bound 
  int CheckV(int i) const { ASSERTION(i>=0 && i < nv); return i;} 
  int CheckT(int i) const { ASSERTION(i>=0 && i < nt); return i;}
  ~Mesh() { delete [] vertices; delete [] triangles;}
 private:
   Mesh(const Mesh &); // pas de construction par copie
   void operator=(const Mesh &);// pas affectation par copy 
   
};


 
