// 
class R3: public R2 {
  friend ostream& operator <<(ostream& f, const R3 & P )
  { f << P.x << ' ' << P.y << ' ' << P.z   ; return f; }
  friend istream& operator >>(istream& f,  R3 & P)
  { f >>  P.x >>  P.y >>  P.z  ; return f; }

public:  
  typedef double R;

  static const int d=3;
  
  typedef R3 Rcross; 
  R z;
 
  R3 () :z(0) {};
  R3 (R a,R b,R c):R2(a,b),z(c)  {}
  R3 (R2 P2):R2(P2),z(0)  {}
  R3 (R2 P2,R zz):R2(P2),z(zz)  {}
  R3 (const R3 & A,const R3 & B) :R2(B.x-A.x,B.y-A.y),z(B.z-A.z)  {}
  R3 & operator=(R2 P2) {x=P2.x;y=P2.y;z=0;return *this;}
  R3   operator+(R3 P)const   {return R3(x+P.x,y+P.y,z+P.z);}
  R3 & operator+=(R3 P)  {x += P.x;y += P.y;z += P.z;return *this;}
  R3   operator-(R3 P)const   {return R3(x-P.x,y-P.y,z-P.z);}
  R3 & operator-=(R3 P) {x -= P.x;y -= P.y;z -= P.z;return *this;}
  R3 & operator*=(R c) {x *= c;y *= c;z *= c;return *this;}
  R3   operator-()const  {return R3(-x,-y,-z);}
  R3   operator+()const  {return *this;}
  R    operator,(R3 P)const  {return  x*P.x+y*P.y+z*P.z;} // produit scalaire
  Rcross  operator^(R3 P)const {return R3(y*P.z-z*P.y ,P.x*z-x*P.z, x*P.y-y*P.x);} // produit mixte
  R3   operator*(R c)const {return R3(x*c,y*c,z*c);}
  R3   operator/(R c)const {return R3(x/c,y/c,z/c);}
  R  &  operator[](int i){ return (&x)[i];}
  friend R3 operator*(R c,R3 P) {return P*c;}
  friend R3 operator/(R c,R3 P) {return P/c;}
};

inline double det(R3 A,R3 B, R3 C) {
  // version optimize bofbof ..... FH a tester
  double  s=1.;
  if(abs(A.x)<abs(B.x)) Exchange(A,B),s = -s;
  if(abs(A.x)<abs(C.x)) Exchange(A,C),s = -s;
  if(abs(A.x)<1e-50)
   {
      s *= A.x;
      A.y /= A.x; A.z /= A.x;
      B.y  -=  A.y*B.x  ;   B.z  -=  A.z*B.x ;
      C.y  -=  A.y*C.x  ;   C.z  -=  A.z*C.x ;
      return s* ( B.y*C.z - B.z*C.y) ;
   }
  else return 0.   ;
};
inline double  det(R3 A,R3 B, R3 C, R3 D) { return det(R3(A,B),R3(A,C),R3(A,D));}
