/*  compilation MacOS
 g++ glplot.cpp -framework Glut -framework OpenGl -framework CoCoa -o glplot

 */ 
// Pour lancer glplot du projet ./glplot carre.msh uh.txt 0.5

#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <fstream>
#include <iostream>
using namespace std;


#include "RNM.hpp"

#include "Mesh2d.hpp"
#include "R3.hpp"

typedef double R;
const  double Pi =  3.14159265358979323846264338328;

using namespace std;

typedef  KN<R> Rn;
const int TheDrawList=1;  // numero de la list d'affichage 

// R ff(R2 P) { return 0.5*cos(P.x*Pi)*sin(P.y*Pi*1.5); }
R ff(R2 P) { return sin(P.x); }
R iv[40];
int compt;
int tempcomp=0;



class Global {    
// une petite classe pour stoker toutes les variables globales
  public:
 int Width , Height;              // taille de l'cran en pixel
 Mesh &Th;                        // maillage courant
 R rapz;
 Rn &f ;                          // solution P1 a affich\'e
 R theta,phi,coef_dist;           // coordonnee polaire de la camera
 R dtheta;                        // vitesse de rotation de la camera 
 R xmin,xmax,ymin,ymax,zmin,zmax; // borne de la scene
  R xm,ym,zm; // point regarde
  R xmouseold,ymouseold; 
  Global(Mesh & TTh,Rn &ff,int height,int width,R rpz) ;
  void SetView() const;           // define le point de vue
  void DefaultView() ;
  void MoveXView(R dx,R dy); // deplace le point regarde de dx,dy dans l'ecran 
  void MakeListDraw() const  ;    // construit la list d'affichage
} *global ;  // la variable global

void   SetColor(R f); 


void isolect(){
// lecture du fichier d isovaleur
//===================================================
  ifstream isoval("isoval.dat");
//   int compt=0;
  float temp;
  while ( (isoval>>temp).good()) {compt=compt+1;}
  isoval.clear();
//   cout <<"compteur d isovaleur:" << compt<<endl;
//   double iv[compt];
  ifstream isoval2("isoval.dat");
  iv[0]=-100.; // tres petite valeur
  for (int i=1; i<compt+1 ; i++) {isoval2 >> iv[i];}
  iv[compt+1]=200.; //tres grande valeur
  isoval2.clear();
//===================================================
}




static void Mouse( int button,int state,int x,int y )
{
  // pour suivre la sourie 
  // ---------------------
  // state up or down 
  if (state == GLUT_DOWN) { global->xmouseold=x,global->ymouseold=y;return;}
  // cout << "Mouse " << button<< " " << state << " " << x-xold << " " << y-yold << endl;
  //  x gauche -> droitre
  //  y  haut -> bas`
  global->phi += (y-global->ymouseold)/(2.*180.);
  global->theta -= (x-global->xmouseold)/(2*180.);
  global->SetView();  
  glutPostRedisplay();
  
}
static void MotionMouse(int x,int y )
{
  // pour suivre la sourie 
 // cout << " MotionMouse " << " " << x << " " << y << endl;
  //  GLuint gtime = glutGet(GLUT_ELAPSED_TIME); //   
  global->phi += (y-global->ymouseold)/(2.*180.);
  global->theta -= (x-global->xmouseold)/(2*180.);
  global->xmouseold=x;
  global->ymouseold=y;
  global->SetView();  
  glutPostRedisplay();
}

void SpecialKey(int key, int x, int y)
{//    point les touche up down etc.
  // cout << " SpecialKey " << key << " " << x << " " << y << " : ";
  R dx(0),dy(0);
    switch (key) {
        case  GLUT_KEY_LEFT:   dx = -1; break;
        case  GLUT_KEY_RIGHT:  dx = +1; break;
        case  GLUT_KEY_DOWN:   dy = -1; break;
        case  GLUT_KEY_UP:     dy = +1; break;
}
   // calcul du deplacement de xm,ym,zm;
  // cout << " " << dx << " " << dy << endl;
    global->MoveXView(dx,dy);
    global->SetView();  
  glutPostRedisplay();

}



Global::Global(Mesh & TTh,Rn &ff,int height,int width,R rpz) 
   : Th(TTh), f(ff)
  {
   Width= width ;
   Height=height;
   theta=45*Pi/180.;
   dtheta=0;
   coef_dist=1;
   rapz=rpz;
   phi = 20*Pi/180.;
   
   // first compute the mesh bound
   const  Vertex & v0= Th(0);
   xmin=xmax=v0.x;
   ymin=ymax=v0.y;
   zmin = rapz*f[0], zmax=rapz*f[0];
   for (int i=0;i<Th.nv;i++)
     {
       const  Vertex & v=Th(i);
       xmin= Min(xmin,v.x);
       ymin= Min(ymin,v.y);
       xmax= Max(xmax,v.x);
       ymax= Max(ymax,v.y); 
       zmin= Min(zmin,f[i]*rapz);
       zmax= Max(zmax,f[i]*rapz);                   
     }
   DefaultView(); 
   }
 
  void Global::MoveXView(R dx,R dy)
  {
  // cout << xm << " " << ym << " " << zm << " apres " ;
   zm -= dy*(zmax-zmin)*rapz/50.;
   xm += dx*(xmax-xmin)*sin(theta)/50;
   ym -= dx*(ymax-ymin)*cos(theta)/50;   
  // cout << xm << " " << ym << " " << zm << endl;
  }
void Global::DefaultView() 
{
  coef_dist =1;
  theta=45*Pi/180.;
  dtheta=0;
  coef_dist=1;
  phi = 20*Pi/180.;
   xm = (xmin+xmax)*0.5;
   ym = (ymin+ymax)*0.5;
    zm = rapz*(zmin+zmax)*0.5;    
}
   
void Global::SetView() const
 {
     glViewport( 0, 0, Width, Height );

    // glMatrixMode(GL_PROJECTION); 
    // glLoadIdentity(); 
     R ratio= (double) Width / (double)  Height; 
     R dx =(xmax-xmin), dy= (ymax-ymin), dz=(zmax-zmin);
         
    // R hx= (  ratio*dy < dx  ) ? dx : dy*ratio ;
    // R hy= hx/ratio ;
     glMatrixMode(GL_MODELVIEW);
     glLoadIdentity(); 
     R focal=10;
     /*     R znear=0.1;
	    R zfare=100;
	    R aspect=ratio;
	    gluPerspective(focal,aspect,znear,zfare);
	    R dist = Max(dx,dy,dz)/atan(focal*Pi/180.)*coef_dist;
	    R camx=xm+cos(phi)*cos(theta)*dist;
	    R camy=ym+cos(phi)*sin(theta)*dist;
	    R camz=zm+dist*sin(phi);     
	    gluLookAt(camx,camy,camz,xm,ym,zm,0.,0.,1.);
     */
     R aspect=ratio; 
     R r=sqrt(dx*dx+dy*dy+dz*dz)/2.; // rayon de sphere contenant la scene
     R dist = r/atan(focal*Pi/180./2.)*coef_dist;
     R camx=xm+cos(phi)*cos(theta)*dist;
     R camy=ym+cos(phi)*sin(theta)*dist;
     R camz=zm+dist*sin(phi);     
     //  apres le changer de repere isometrique
     //  0,0,0 est le point de vue
     //  0,0,-dist est le point regarde
     //  donc tout l'objet est ente dist-r et dist+r
     gluPerspective(focal,aspect,dist-r,dist+r);

     gluLookAt(camx,camy,camz,xm,ym,zm,0.,0.,1.);
     
     
 }


 void   SetColor(R f)
{
  float r,g,b; 

  for (int i=0 ; i<compt;i++)
  if ( (iv[i]<= f) && (iv[i+1] >f) ){
tempcomp = i+1;
  while( i>20){i=i-20;}
    switch (i) {
    case 0: r = 0.8; g = 0.4; b = 0.4; break;
    case 1: r = 1.; g = 0.; b = 0.4; break;
    case 2: r = 1.; g = 0.8; b = 0.; break;
    case 3: r = 1.; g = 0.2; b = 0.;  break;
    case 4: r = 1.; g = 0.6; b = 0.;  break;
    case 5: r = 0.; g = 0.4; b = 0.; break;
    case 6: r = 0.; g = 1.; b = 0.; break;
    case 7: r = 0.; g = 0.; b = 0.6; break;
    case 8: r = 0.; g = 0.; b = 0.8; break;
    case 9: r = 0.; g = 0.; b = 1.; break;
    case 10: r = 0.; g = 0.2; b = 1.; break;
    case 11: r = 0.; g = 0.4; b = 1.; break;
    case 12: r = 0.; g = 0.6; b = 1.; break;
    case 13: r = 0.; g = 0.8; b = 1.; break;
    case 14: r = 0.; g = 1.; b = 0.2; break;
    case 15: r = 0.; g = 1.; b = 0.4; break;
    case 16: r = 0.; g = 1.; b = 0.6; break;
    case 17: r = 0.; g = 1.; b = 0.8; break;
    case 18: r = 0.; g = 1.; b = 1.; break;
    case 19: r = 1.; g = 0.; b = 1.; break;

    }
  }
  glColor3f(r,g,b);

}

//=========================================================================================
//===============	  Determine les isopoints des triangles		===================
//=========================================================================================
R3 Calpoint ( const R3 & v1, const R3 & v2, int nbcoup){
R3 resul, vmax , vmin;
// cout << "isoval 1"<< iv[1] << "  isoend"<< iv[compt+1]<<endl; cout <<"resul" <<vmax<<endl ;
if( (v1.z-v2.z)>0.) {vmax.x=v1.x, vmax.z=v1.z ,vmax.y=v1.y , vmin.x=v2.x, vmin.z=v2.z ,vmin.y=v2.y;}
if( (v1.z-v2.z)<0.) {vmax.x=v2.x, vmax.z=v2.z ,vmax.y=v2.y , vmin.x=v1.x, vmin.z=v1.z ,vmin.y=v1.y;}
if (iv[1]> vmax.z) {return resul=vmax;}
R isoval;
R co;
if (nbcoup==0) {
  for (int m=0 ; m<compt+2;m++){
      if ((iv[m]<= vmax.z) && (iv[m] >= vmin.z)) { isoval=iv[m]; }}
	R vmm= vmax.z-vmin.z;
	resul = (vmin*((isoval -vmin.z)/vmm) +(vmax*(vmax.z-isoval)/vmm)); 
resul.z=isoval;
return resul;}
  if  (nbcoup==1){
     for (int m=0 ; m<compt+2;m++){
       if ( ((iv[m]<= vmax.z) && (iv[m] >= vmin.z))&& ((iv[m+1]< vmax.z) && (iv[m+1] > vmin.z)) ){ isoval=iv[m]; co=iv[m+1];}}
	R vmm= vmax.z-vmin.z;
	resul = (vmin*((isoval -vmin.z)/vmm) +(vmax*(vmax.z-isoval)/vmm)); 
resul.z=co;
return resul;}
  if  (nbcoup==2){
    for (int m=0 ; m<compt+2;m++){
       if ( ((iv[m]<= vmax.z) && (iv[m] >= vmin.z))&& ((iv[m+1]<= vmax.z) && (iv[m+1] >= vmin.z)) ){ isoval=iv[m+1]; co=iv[m];}}
	R vmm= vmax.z-vmin.z;
	resul = (vmin*((isoval -vmin.z)/vmm) +(vmax*(vmax.z-isoval)/vmm)); 
        resul.z=co;
// 	cout << "le resultat " << resul.x << " "<< resul.y << " " << resul.z<<endl;
	return resul;}
cout << "erreur dans calpoint"<<endl;
return resul;}
//=========================================================================================


//=========================================================================================
//===============    Determine dans quel cas d intersection on est	===================
//=========================================================================================
int Labeliseur ( const R3 & v1, const R3 & v2, const R3 & v3){
// 0 : 3 meme isovaleur
// 1 : v1 et v2 ont meme isovaleur
// 2 : v1 et v2 ont meme isovaleur
// 3 : v2 et v3 ont meme isovaleur
// 9 : 3 isovaleurs differentes

// 8 : erreur
int labli;
  for (int i=0 ; i<compt +2;i++){
  // cas ou les 3 points sont dans la meme tranche d isovaleur
  if ((iv[i]<=v1.z)&&(iv[i+1]>=v1.z)) 
     {	if ((iv[i]<=v2.z)&&(iv[i+1]>=v2.z)) { 
		if ((iv[i]<=v3.z)&&(iv[i+1]>=v3.z)) {return labli=0;} // cas ou ils ont la mm isovaleur
                return labli=1;}// cas ou v1 et V2 ont la mm isovaleur
	if ((iv[i]<=v3.z)&&(iv[i+1]>=v3.z)) return labli=2 ;}  // cas ou v1 et V3 ont la mm isovaleur
  if ((iv[i]<=v2.z)&&(iv[i+1]>=v2.z)) 
     {	if ((iv[i]<=v3.z)&&(iv[i+1]>=v3.z)) { return labli=3;}  }// cas ou v3 et V2 ont la mm isovaleur
  if (i==compt+1){return labli=9;}}    // les 3 points ont des isovaleurs differentes
cout <<"erreur"<<endl;
return 8;} 
//=========================================================================================


//=========================================================================================
//===============	 	    Traceur de tout		        ===================
//=========================================================================================

void Global::MakeListDraw() const
{

  glNewList(TheDrawList,GL_COMPILE); // save  la list sans affichage

  for (int i=0;i<Th.nt;i++)
  { 
    const Triangle & K(Th[i]); 
    int i0= Th(K[0]),  i1= Th(K[1]),   i2= Th(K[2]) ;  
    R3 A0(K[0],rapz*f[i0]);
    R3 A1(K[1],rapz*f[i1]);
    R3 A2(K[2],rapz*f[i2]);

int aa=Labeliseur(A0,A1,A2);

if (aa==0 ){
glBegin(GL_POLYGON);
  SetColor(A0.z);
  glVertex3f(A0.x, A0.y, A0.z);
  glVertex3f(A1.x, A1.y, A1.z);
  glVertex3f(A2.x, A2.y, A2.z);
  glEnd();}

if (aa==1){

R3 A3=Calpoint (A0,A2,0);
R3 A4=Calpoint (A1,A2,0);
glBegin(GL_POLYGON);
  SetColor(A0.z);

  glVertex3f(A0.x, A0.y, A0.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glVertex3f(A1.x, A1.y, A1.z);
  glEnd();

glBegin(GL_POLYGON);
  SetColor(A2.z);
  glVertex3f(A2.x, A2.y, A2.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glEnd();}

if (aa==2){
R3 A3=Calpoint ( A0, A1 ,0);
R3 A4=Calpoint ( A1, A2 ,0);
glBegin(GL_POLYGON);
  SetColor(A0.z);

  glVertex3f(A0.x, A0.y, A0.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glVertex3f(A2.x, A2.y, A2.z);
  glEnd();

glBegin(GL_POLYGON);
  SetColor(A1.z);
  glVertex3f(A1.x, A1.y, A1.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A4.x, A4.y, A3.z);
  glEnd();}


if (aa==3){
R3 A4=Calpoint ( A0, A2 ,0);
R3 A3=Calpoint ( A0, A1 ,0);
glBegin(GL_POLYGON);
  SetColor(A1.z);

  glVertex3f(A2.x, A2.y, A2.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A1.x, A1.y, A1.z);
  glEnd();
glBegin(GL_POLYGON);
  SetColor(A0.z);
  glVertex3f(A0.x, A0.y, A0.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glEnd();}


if (aa==9){
  if ( (Max(A0.z,A1.z,A2.z))!=A0.z  && (Min(A0.z,A1.z,A2.z))!=A0.z ){
R3 A3,A4;
if( (A1.z-A2.z)>0.) { 
A3=Calpoint ( A1, A2 ,1);
A4=Calpoint ( A1, A2 ,2);  }
if( (A1.z-A2.z)<0.){
 A4=Calpoint ( A1, A2 ,1);
 A3=Calpoint ( A1, A2 ,2); }
R3 A5=Calpoint ( A0, A1 ,0);
R3 A6=Calpoint ( A0, A2 ,0); 

glBegin(GL_POLYGON);
  SetColor(A2.z);
  glVertex3f(A2.x, A2.y, A2.z);
  glVertex3f(A6.x, A6.y, A6.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glEnd();
glBegin(GL_POLYGON);
  SetColor(A0.z);
  glVertex3f(A0.x, A0.y, A0.z);
  glVertex3f(A6.x, A6.y, A6.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glVertex3f(A5.x, A5.y, A5.z); 
  glEnd();
glBegin(GL_POLYGON);
  SetColor(A1.z);
  glVertex3f(A1.x, A1.y, A1.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glVertex3f(A5.x, A5.y, A5.z);
  glEnd();
}

if ( (Max(A0.z,A1.z,A2.z))!=A1.z  && (Min(A0.z,A1.z,A2.z))!=A1.z ){
R3 A3,A4;
if( (A0.z-A2.z)>0.) { 
A3=Calpoint (A0, A2 ,1);
A4=Calpoint (A0, A2 ,2);  }

if( (A0.z-A2.z)<0.){
A4=Calpoint ( A0, A2 ,1);
A3=Calpoint ( A0, A2 ,2); }

R3 A5=Calpoint ( A0, A1 ,0);
R3 A6=Calpoint ( A1, A2 ,0);

glBegin(GL_POLYGON);
  SetColor(A2.z);
  glVertex3f(A6.x, A6.y, A6.z);
  glVertex3f(A2.x, A2.y, A2.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glEnd();
glBegin(GL_POLYGON);
  SetColor(A1.z);
  glVertex3f(A1.x, A1.y, A1.z);
  glVertex3f(A5.x, A5.y, A5.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glVertex3f(A6.x, A6.y, A6.z);
  glEnd();
glBegin(GL_POLYGON);
  SetColor(A0.z);
  glVertex3f(A0.x, A0.y, A0.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A5.x, A5.y, A5.z);
  glEnd();}

if ( (Max(A0.z,A1.z,A2.z))!=A2.z  && (Min(A0.z,A1.z,A2.z))!=A2.z ){
R3 A3,A4;
if( (A1.z-A0.z)>0.) { 
 A3=Calpoint ( A1, A0 ,1);
 A4=Calpoint ( A1, A0 ,2);  }
if( (A1.z-A0.z)<0.){
 A4=Calpoint ( A1, A0 ,1);
 A3=Calpoint ( A1, A0 ,2);  }

R3 A5=Calpoint ( A1, A2 ,0);
R3 A6=Calpoint ( A0, A2 ,0);

glBegin(GL_POLYGON);
  SetColor(A0.z);
  glVertex3f(A6.x, A6.y, A6.z);
  glVertex3f(A0.x, A0.y, A0.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glEnd();
glBegin(GL_POLYGON);
  SetColor(A2.z);
  glVertex3f(A2.x, A2.y, A2.z);
  glVertex3f(A5.x, A5.y, A5.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A4.x, A4.y, A4.z);
  glVertex3f(A6.x, A6.y, A6.z);
  glEnd();
glBegin(GL_POLYGON);
  SetColor(A1.z);
  glVertex3f(A1.x, A1.y, A1.z);
  glVertex3f(A3.x, A3.y, A3.z);
  glVertex3f(A5.x, A5.y, A5.z);
  glEnd();}
}
   }
  glEndList();  // fin de la list
 
}
//=========================================================================================




void Clean() 
{
    glClearColor(1.0, 1.0, 1.0, 0.0);
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
}

static void Reshape( int width, int height )
{   
    global->Width  = width;
    global->Height = height;  
    global->SetView();
    glutPostRedisplay();
}


static void Key( unsigned char key, int x, int y )
{
   switch (key) {
      case 27: // esc char
         exit(0);
         break;
      case '+':  
      	global->coef_dist /= 1.2;
      	break;
      case '-':  
      	global->coef_dist *= 1.2;
      	break;
      case 'g':  
      	global->theta += Pi/180.;
      	break;
      case 'd':  
      	global->theta -= Pi/180.;
      	break;
      case 'h':  
      	global->phi += Pi/180.;
      	break;
      case 'b':  
      	global->phi -= Pi/180.;
      	break;
      case 'a':
        global->dtheta = Pi/(5*1800.);
        break;	
      case 's':
        global->dtheta = 0;
        break;	
      case '=':
	global->DefaultView(); 
        break;
        
      	
   }
   global->SetView();  
   glutPostRedisplay();
}

void Display(void)
{ 
    Clean();
    //* glEnable(GL_COLOR_MATERIAL);
    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL); // mode affichage des polygones  
    glCallList(TheDrawList);    
    glFlush();    
    glutSwapBuffers();
}

static void Idle( void )
{
  if (global->dtheta)
   {
     global->theta += Pi/1800.;
     global->SetView();
     glutPostRedisplay();
   }
	 
}


int main(int argc, char** argv)
{
isolect();
// cout << "premier et deuxieme isovaleur test:"<< iv[1] << " et  "<<iv[2]<<endl;
// cout << "compteur d isovaleur " << compt<< endl;

// procedure par defaut
//================================================
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
//================================================

// pour la beaute ( taille de la fenetre, puis emplacement)
// j ai choisi le milieu de l ecran pour 1280x800
//================================================
    int Height = 512;
    int Width = 512; 
    glutInitWindowSize(Width , Height);
    glutInitWindowPosition(384, 144);
//================================================

//====================defaut suite================
    glutCreateWindow("Fenetre de u");
//================================================

    glutPushWindow(); // pour afficher la fenetre devant. ( change l ordre des fenetres courantes )
//son contraire void glutPopWindow ();

    assert(argc>1);
    R rapz=1; 
    if (argc>3) rapz=atof(argv[3]);
    cout << " Rap z " << rapz << endl;
    Mesh Th(argv[1]);
    Rn f(Th.nv); 
    if(argc > 2) 
    {
	ifstream fdat(argv[2]);
	assert(fdat.good());
	int n;      
	fdat >> n;
	assert(n = Th.nv); 
	for(int i=0;i<n;i++)
	    fdat >> f[i];
    } // pour ferme le fichier (la variable fdat est detruite)
    else
	for(int i=0;i<Th.nv;i++)
	    f[i] = ff(Th(i)); // si on n a pas de fichier solution , il affichera sin x
    global=new Global(Th,f,Height,Width,rapz);
    global->MakeListDraw();    
    global->SetView(); 
    
    glEnable(GL_DEPTH_TEST); 
    glutReshapeFunc( Reshape ); // pour changement de fenetre 
    glutKeyboardFunc( Key );    // pour les evenements clavier
    glutSpecialFunc(SpecialKey);
    glutMouseFunc(Mouse);       // pour les evenements souris
    glutMotionFunc(MotionMouse); // les mouvements  de la souris
    glutDisplayFunc( Display ); // l'affichage
    glutIdleFunc( Idle );       // l'animation automatique
    
    glutMainLoop(); 
    return 0;
}


